//
//  Ajustes.m
//  COMUNICADOR
//
//  Created by JOSE CRUZ PEREZ PI on 31/05/11.
//  Copyright 2011 UNIVERSIDAD PUBLICA DE NAVARRA. All rights reserved.
//

#import "Ajustes.h"
#import "COMUNICADORViewController.h"
#import "EditarAlbumFavorito.h"
#import "Personalizacion.h"

@implementation Ajustes

@synthesize rutaFichero;
@synthesize ajustes;

@synthesize controladorViewController;
@synthesize EditarAlbumFavoritoVista;
@synthesize controladorPersonalizacion;

@synthesize segmentedControl_resp_negativa;
@synthesize segmentedControl_tiempo_pulsacion;
@synthesize segmentedControl_minusc_mayusc;
@synthesize segmentedControl_cast_ing;

@synthesize label_resp_negativa;
@synthesize label_tiempo_pulsacion;
@synthesize label_tamano_letra;
@synthesize label_idioma;
@synthesize label_pictos_personalizar;
@synthesize label_album_favorito_personalizar;

@synthesize but_pictos_personalizar;
@synthesize but_album_favorito_personalizar;
@synthesize but_guardar_ajustes;
@synthesize but_inicio;

@synthesize resp_negativa;
@synthesize tiempo_pulsacion;
@synthesize tipo_letra;

@synthesize resp_negativa_string;
@synthesize tiempo_pulsacion_string;
@synthesize tipo_letra_string;



- (id)initWithNibName:(NSString *)nibNameOrNil bundle:(NSBundle *)nibBundleOrNil
{
    self = [super initWithNibName:nibNameOrNil bundle:nibBundleOrNil];
    if (self) {
        // Custom initialization
    }
    return self;
}

- (void)dealloc
{
    [super dealloc];
}

- (void)didReceiveMemoryWarning
{
    // Releases the view if it doesn't have a superview.
    [super didReceiveMemoryWarning];
    
    // Release any cached data, images, etc that aren't in use.
}

#pragma mark - View lifecycle

- (void)viewDidLoad
{
    NSString *fichero= [self rutaFichero];
    if ([[NSFileManager defaultManager] fileExistsAtPath:fichero]) 
    {
        NSArray *listado =[[NSArray alloc] initWithContentsOfFile:fichero];
        ajustes=[[NSMutableArray alloc]initWithArray:listado];
        [self mostrarAjustes];
    }
    else
    {
        ajustes=[[NSMutableArray alloc]init];
        
        resp_negativa=1;
        tiempo_pulsacion=0.5;
        tipo_letra=20;
        
        [self guardarAjustes];
    }
    
    [super viewDidLoad];
    // Do any additional setup after loading the view from its nib.
}

- (int)CargarRespuestaNegativa
{
    
    return resp_negativa;
}

- (void)viewDidUnload
{
    [super viewDidUnload];
    // Release any retained subviews of the main view.
    // e.g. self.myOutlet = nil;
}

- (BOOL)shouldAutorotateToInterfaceOrientation:(UIInterfaceOrientation)interfaceOrientation
{
    // Return YES for supported orientations
	return YES;
}

- (void)viewDidAppear:(BOOL)animated {
	[super viewDidAppear:animated];
    selectedUnit_resp_negativa=segmentedControl_resp_negativa.selectedSegmentIndex;
    [self cambioRespuestaNegativa];
	selectedUnit3 = segmentedControl_tiempo_pulsacion.selectedSegmentIndex;
	[self cambioTiempoPulsacion];
    selectedUnit_cast_ing = segmentedControl_cast_ing.selectedSegmentIndex;
	[self cambioIdioma];
    selectedUnit_minusc_mayusc = segmentedControl_minusc_mayusc.selectedSegmentIndex;
	[self cambioMayusculasMinusculas];
    
	
}

- (IBAction)segmentedControlValueChangedRespNegativa
{
    selectedUnit_resp_negativa = segmentedControl_resp_negativa.selectedSegmentIndex;
    [self cambioRespuestaNegativa];
    [self.view setNeedsDisplay];
}

- (IBAction)segmentedControlValueChanged3 {
	selectedUnit3 = segmentedControl_tiempo_pulsacion.selectedSegmentIndex;
	[self cambioTiempoPulsacion];
	[self.view setNeedsDisplay];
}

- (IBAction)segmentedControlValueChanged4 {
	selectedUnit_cast_ing = segmentedControl_cast_ing.selectedSegmentIndex;
	[self cambioIdioma];
	[self.view setNeedsDisplay];
}

- (IBAction)segmentedControlValueChanged6 {
	selectedUnit_minusc_mayusc = segmentedControl_minusc_mayusc.selectedSegmentIndex;
	[self cambioMayusculasMinusculas];
	[self.view setNeedsDisplay];
}

- (void)cambioRespuestaNegativa
{
    if (selectedUnit_resp_negativa == 0) {
		resp_negativa=0;
		[self.view setNeedsDisplay];
	}
	else if (selectedUnit_resp_negativa == 1) {
		resp_negativa=1;
		[self.view setNeedsDisplay];
	}
}

- (void)cambioTiempoPulsacion {
	if (selectedUnit3 == 0) {
		tiempo_pulsacion=0.5;
		[self.view setNeedsDisplay];
	}
	else if (selectedUnit3 == 1) {
		tiempo_pulsacion=1;
		[self.view setNeedsDisplay];
	}
	else if (selectedUnit3 == 2) {
		tiempo_pulsacion=2;
		[self.view setNeedsDisplay];
	}
	else if (selectedUnit3 == 3) {
		tiempo_pulsacion=3;
		[self.view setNeedsDisplay];
	}
	else if (selectedUnit3 == 4) {
		tiempo_pulsacion=4;
		[self.view setNeedsDisplay];
	}
    
    //[seleccionAlbumAjustes setAjustes:tiempo_pulsacion];
	
}

- (void)cambioIdioma 
{
	if (selectedUnit_cast_ing == 0 && selectedUnit_minusc_mayusc==0) 
    {
		tipo_letra=20;
		[self.view setNeedsDisplay];
	}
	else if (selectedUnit_cast_ing == 0 && selectedUnit_minusc_mayusc==1) 
    {
		tipo_letra=30;
		[self.view setNeedsDisplay];
	}
    else if (selectedUnit_cast_ing == 1 && selectedUnit_minusc_mayusc==0) 
    {
		tipo_letra=50;
		[self.view setNeedsDisplay];
	}
    else if (selectedUnit_cast_ing == 1 && selectedUnit_minusc_mayusc==1) 
    {
		tipo_letra=60;
		[self.view setNeedsDisplay];
	}
}

- (void)cambioMayusculasMinusculas 
{
	if (selectedUnit_cast_ing == 0 && selectedUnit_minusc_mayusc==0) 
    {
		tipo_letra=20;
		[self.view setNeedsDisplay];
	}
	else if (selectedUnit_cast_ing == 0 && selectedUnit_minusc_mayusc==1) 
    {
		tipo_letra=30;
		[self.view setNeedsDisplay];
	}
    else if (selectedUnit_cast_ing == 1 && selectedUnit_minusc_mayusc==0) 
    {
		tipo_letra=50;
		[self.view setNeedsDisplay];
	}
    else if (selectedUnit_cast_ing == 1 && selectedUnit_minusc_mayusc==1) 
    {
		tipo_letra=60;
		[self.view setNeedsDisplay];
	}
}
/*
 -(IBAction) PULSAR_BOTON_OPCIONES: (id) sender
 {
 //NSUserDefaults *defaults = [NSUserDefaults standardUserDefaults];
 //resp_negativa = [defaults boolForKey:@"Respuesta negativa"];
 
 if (resp_negativa == NO)
 {
 [BOTON_AJUSTES setTitle:@"ON" forState:0];
 resp_negativa = YES;
 
 }
 else
 {
 [BOTON_AJUSTES setTitle:@"OFF" forState:0];
 resp_negativa = NO;
 }
 }
 */
- (IBAction)ajustes_personalizar_pictos
{
    [controladorPersonalizacion viewDidLoad];
    controladorPersonalizacion=[[Personalizacion alloc] initWithNibName:@"Personalizacion" bundle:[NSBundle mainBundle]];
    
    [self.view addSubview:controladorPersonalizacion.view];
}

- (NSString *)rutaFichero
{
    
    NSArray *rutas = NSSearchPathForDirectoriesInDomains(NSDocumentDirectory, NSUserDomainMask, YES);
    NSLog(@"Directorios: %@", rutas);
    
    NSString *directorio = [rutas objectAtIndex:0];
    
    return [directorio stringByAppendingPathComponent:ficheroPersistente];
}

- (void) mostrarAjustes
{    
    NSDictionary *item =[ajustes objectAtIndex:0];
    
    //se convierten los valores a números
    resp_negativa= [[item objectForKey:KEY_RESP_NEGATIVA] intValue];
    tiempo_pulsacion = [[item objectForKey:KEY_TIEMPO_PULSACION] intValue];
    tipo_letra = [[item objectForKey:KEY_TIPO_LETRA] intValue];
    
    
    
    int idioma;
    int tamano_letra;
    
    if (tipo_letra<40)
    {
        idioma=0; 
        label_resp_negativa.text=@"RESPUESTA NEGATIVA";
        label_tiempo_pulsacion.text=@"TIEMPO DE PULSADO (segundos)";
        label_tamano_letra.text=@"TIPO DE LETRA";
        label_idioma.text=@"IDIOMA";
        label_pictos_personalizar.text=@"INTRODUCE TUS PICTOGRAMAS O MODIFICA LOS EXISTENTES";
        label_album_favorito_personalizar.text=@"PERSONALIZA TU ÁLBUM DE FAVORITOS";
        
        [segmentedControl_minusc_mayusc setTitle:@"minúsculas" forSegmentAtIndex:0];
        [segmentedControl_minusc_mayusc setTitle:@"MAYÚSCULAS" forSegmentAtIndex:1];
        [segmentedControl_cast_ing setTitle:@"Castellano" forSegmentAtIndex:0];
        [segmentedControl_cast_ing setTitle:@"Inglés" forSegmentAtIndex:1];
        
        [but_pictos_personalizar setTitle:@"Personalizar pictos" forState:normal];
        [but_album_favorito_personalizar setTitle:@"Personalizar álbum" forState:normal];
        [but_guardar_ajustes setTitle:@"GUARDAR" forState:normal];
        [but_inicio setTitle:@"INICIO" forState:normal];
        
        
    }
    else
    {
        idioma=1;
        label_resp_negativa.text=@"SET ACTIVE 'SAY NO'";
        label_tiempo_pulsacion.text=@"TOUCHING TIME (seconds)";
        label_tamano_letra.text=@"FONT TYPE";
        label_idioma.text=@"LANGUAGE";
        label_pictos_personalizar.text=@"ADD OR EDIT YOUR OWN PICTOS";
        label_album_favorito_personalizar.text=@"CHOOSE YOUR FAVOURITE ALBUM PICTURES";
        
        [segmentedControl_minusc_mayusc setTitle:@"small letter" forSegmentAtIndex:0];
        [segmentedControl_minusc_mayusc setTitle:@"CAPITAL LETTER" forSegmentAtIndex:1];
        [segmentedControl_cast_ing setTitle:@"Spanish" forSegmentAtIndex:0];
        [segmentedControl_cast_ing setTitle:@"English" forSegmentAtIndex:1];
        
        [but_pictos_personalizar setTitle:@"Pictos personalize" forState:normal];
        [but_album_favorito_personalizar setTitle:@"Album personalize" forState:normal];
        [but_guardar_ajustes setTitle:@"SAVE" forState:normal];
        [but_inicio setTitle:@"HOME" forState:normal];
    }
    if (tipo_letra==20 || tipo_letra==50)
    {
        tamano_letra=0;
    }
    else
    {
        tamano_letra=1;
    }
    
    NSLog(@"negativa %i, pulsacion %i, idioma %i, tamanoletra %i", resp_negativa, tiempo_pulsacion, idioma, tamano_letra);
    
    //se colocan los segmentos seleccionados correspondientes.
    [segmentedControl_resp_negativa setSelectedSegmentIndex:resp_negativa];
	[segmentedControl_tiempo_pulsacion setSelectedSegmentIndex:tiempo_pulsacion];
    [segmentedControl_cast_ing setSelectedSegmentIndex:idioma];
    [segmentedControl_minusc_mayusc setSelectedSegmentIndex:tamano_letra];
}

- (void) guardarAjustes;
{
    if (selectedUnit_cast_ing == 0 && selectedUnit_minusc_mayusc==0) 
    {
		tipo_letra=20;
		[self.view setNeedsDisplay];
	}
	else if (selectedUnit_cast_ing == 0 && selectedUnit_minusc_mayusc==1) 
    {
		tipo_letra=30;
		[self.view setNeedsDisplay];
	}
    else if (selectedUnit_cast_ing == 1 && selectedUnit_minusc_mayusc==0) 
    {
		tipo_letra=50;
		[self.view setNeedsDisplay];
	}
    else if (selectedUnit_cast_ing == 1 && selectedUnit_minusc_mayusc==1) 
    {
		tipo_letra=60;
		[self.view setNeedsDisplay];
    }
    
    resp_negativa_string=[NSString stringWithFormat:@"%d",resp_negativa];
    tiempo_pulsacion_string=[NSString stringWithFormat:@"%d",tiempo_pulsacion];
    tipo_letra_string=[NSString stringWithFormat:@"%d",tipo_letra];
    
    NSLog(@"negativa %@, tipo letra %i",resp_negativa_string, tipo_letra);
    
    NSDictionary *item =[NSDictionary dictionaryWithObjectsAndKeys:tipo_letra_string, KEY_TIPO_LETRA, tiempo_pulsacion_string, KEY_TIEMPO_PULSACION, resp_negativa_string, KEY_RESP_NEGATIVA, nil];
    [self.ajustes removeAllObjects];
    [self.ajustes addObject:item];
    
    [ajustes writeToFile:[self rutaFichero] atomically:YES];
    
    [self mostrarAjustes];
    
    
    

}

- (IBAction)ajustes_personalizar_album_favorito
{
    EditarAlbumFavoritoVista=[[EditarAlbumFavorito alloc] initWithNibName:@"EditarAlbumFavorito" bundle:[NSBundle mainBundle]];
    
    [self.view addSubview:EditarAlbumFavoritoVista.view];
}

-(IBAction) PULSAR_BOTON_SALIR_AJUSTES: (id) sender
{
     [self guardarAjustes];
	[self.view removeFromSuperview];
}

- (IBAction) PULSAR_BOTON_GUARDAR_AJUSTES: (id)sender
{
    [self guardarAjustes];
    if (tipo_letra<40) // IDIOMA CASTELLANO
    {
        
        UIAlertView *alertView = [[UIAlertView alloc] initWithTitle:@"ENHORABUENA" message:@"Sus ajustes han sido guardados correctamente" delegate:self cancelButtonTitle:nil otherButtonTitles:@"Ok", nil];
        [alertView show];
        [alertView release];
        
        
    }
    else //IDIOMA INGLÉS
    {
        UIAlertView *alertView = [[UIAlertView alloc] initWithTitle:@"CONGRATULATIONS" message:@"Your changes have been saved correctly" delegate:self cancelButtonTitle:nil otherButtonTitles:@"Ok", nil];
        [alertView show];
        [alertView release];
        
        
    }
    
}


@end
