//
//  Pizarra.m
//  COMUNICADOR
//
//  Created by JOSE CRUZ PEREZ PI on 27/05/11.
//  Copyright 2011 UNIVERSIDAD PUBLICA DE NAVARRA. All rights reserved.
//

#import <QuartzCore/QuartzCore.h>
#import "Pizarra.h"
#import "Ajustes.h"



@implementation Pizarra

@synthesize ControladorAjustes;

@synthesize segmentedControl;
@synthesize segmentedControl_grosor;
@synthesize segmentedControl_color;

@synthesize but_menu_cargar_imagen;
@synthesize but_menu_deshacer;
@synthesize but_menu_borrar_todo;
@synthesize but_menu_guardar_imagen;
@synthesize but_menu_inicio;

@synthesize popover;
@synthesize copyImage;



- (id)initWithNibName:(NSString *)nibNameOrNil bundle:(NSBundle *)nibBundleOrNil
{
    self = [super initWithNibName:nibNameOrNil bundle:nibBundleOrNil];
    if (self) {
        // Custom initialization
    }
    return self;
}


- (void)didReceiveMemoryWarning
{
    // Releases the view if it doesn't have a superview.
    [super didReceiveMemoryWarning];
    
    // Release any cached data, images, etc that aren't in use.
}

#pragma mark - View lifecycle

- (void)viewDidLoad
{
    ControladorAjustes =[[Ajustes alloc]init];
    
    drawImage = [[UIImageView alloc] initWithImage:nil];
	drawImage.frame = VISTA_PRIMERA_PIZARRA.frame;
	[VISTA_PRIMERA_PIZARRA addSubview:drawImage];
	VISTA_PRIMERA_PIZARRA.backgroundColor = [UIColor whiteColor];
	userMoved = 0;
	menupizarra=0;
    
    [self.view addSubview:VISTA_PRIMERA_PIZARRA];
    [VISTA_PRIMERA_PIZARRA setBackgroundColor:[UIColor whiteColor]];
    [barra_pizarra addSubview:segmentedControl];
    [barra_pizarra addSubview:segmentedControl_color];
    [barra_pizarra addSubview:segmentedControl_grosor];
    drawImage.image = nil;
    [VISTA_PRIMERA_PIZARRA setNeedsDisplay];
    colorRed = 0.0f;
    colorGreen = 0.0f; 
    colorBlue = 0.0f;
    lineWidth = 1;
    segmentedControl.selectedSegmentIndex=0;
    segmentedControl_grosor.selectedSegmentIndex=0;
    segmentedControl_color.selectedSegmentIndex=0;
    [barra_pizarra setFrame:CGRectMake(0, 680, 1024, 68)];
    [segmentedControl setFrame:CGRectMake(614, 684, 150, 50)];
    [segmentedControl_grosor setFrame:CGRectMake(390, 684, 300, 50)];
    [segmentedControl_color setFrame:CGRectMake(70, 684, 300, 50)];
    
    [self Ajustar];

    [super viewDidLoad];
    // Do any additional setup after loading the view from its nib.
}


- (void)Ajustar
{
    [ControladorAjustes viewDidLoad];
    ajuste_resp_negativa=ControladorAjustes.resp_negativa;
    ajuste_tiempo_pulsacion=ControladorAjustes.tiempo_pulsacion;
    ajuste_tipo_letra=ControladorAjustes.tipo_letra;
    
    NSLog(@"respuesta negativa %i, tiempo pulsacion %i, tipo letra %i",ajuste_resp_negativa,ajuste_tiempo_pulsacion,ajuste_tipo_letra);
}

- (void)viewDidUnload
{
    [super viewDidUnload];
    // Release any retained subviews of the main view.
    // e.g. self.myOutlet = nil;
}

- (BOOL)shouldAutorotateToInterfaceOrientation:(UIInterfaceOrientation)interfaceOrientation
{
    // Return YES for supported orientations
	return YES;
}

- (IBAction) PULSAR_VOLVER_PIZARRA: (id) sender{
	
	[MENU_PIZARRA removeFromSuperview];
	menupizarra=0;
	[self.view removeFromSuperview];
    colorRed = 0.0;
    colorGreen = 0.0;
    colorBlue = 0.0;
    segmentedControl_color.selectedSegmentIndex=0;
    segmentedControl_grosor.selectedSegmentIndex=0;
    segmentedControl.selectedSegmentIndex=0;


	
}

- (void)touchesBegan:(NSSet *)touches withEvent:(UIEvent *)event {
	
	self.copyImage = drawImage.image;
	
	if (menupizarra==1){
		[MENU_PIZARRA removeFromSuperview];
		menupizarra=0;
	}
    
	userSwiped = NO;
	UITouch *touch = [touches anyObject];
	ultimoPunto = [touch locationInView:VISTA_PRIMERA_PIZARRA];
	ultimoPunto.y -= 1;//por la statusbar
	
	
	
    
}

- (void)touchesMoved:(NSSet *)touches withEvent:(UIEvent *)event {
	
	userSwiped = YES;
	
	UITouch *touch = [touches anyObject];   
	CGPoint currentPoint = [touch locationInView:VISTA_PRIMERA_PIZARRA];
	
	currentPoint.y -= 1;
	
	
	UIGraphicsBeginImageContext(VISTA_PRIMERA_PIZARRA.frame.size);
	[drawImage.image drawInRect:  CGRectMake(0, 0, VISTA_PRIMERA_PIZARRA.frame.size.width, VISTA_PRIMERA_PIZARRA.frame.size.height)];
	CGContextSetLineCap(UIGraphicsGetCurrentContext(), kCGLineCapRound);
	CGContextSetLineWidth(UIGraphicsGetCurrentContext(), lineWidth);
	CGContextSetRGBStrokeColor(UIGraphicsGetCurrentContext(), colorRed,colorGreen, colorBlue, 1.0);
	CGContextBeginPath(UIGraphicsGetCurrentContext());
	CGContextMoveToPoint(UIGraphicsGetCurrentContext(), ultimoPunto.x, ultimoPunto.y);
	CGContextAddLineToPoint(UIGraphicsGetCurrentContext(), currentPoint.x, currentPoint.y);
	CGContextStrokePath(UIGraphicsGetCurrentContext());
	drawImage.image = UIGraphicsGetImageFromCurrentImageContext();
	UIGraphicsEndImageContext();
	
	ultimoPunto = currentPoint;
	
	userMoved++;
	
	if (userMoved == 10) {
		userMoved = 0;
	}
	
	
	
}

- (void)touchesEnded:(NSSet *)touches withEvent:(UIEvent *)event {
	
	
	if(!userSwiped) {
		UIGraphicsBeginImageContext(VISTA_PRIMERA_PIZARRA.frame.size);
		[drawImage.image drawInRect:CGRectMake(0, 0, VISTA_PRIMERA_PIZARRA.frame.size.width, VISTA_PRIMERA_PIZARRA.frame.size.height)];
		CGContextSetLineCap(UIGraphicsGetCurrentContext(), kCGLineCapRound);
		CGContextSetLineWidth(UIGraphicsGetCurrentContext(), lineWidth);
		CGContextSetRGBStrokeColor(UIGraphicsGetCurrentContext(), colorRed,colorGreen, colorBlue, 1.0);
		CGContextMoveToPoint(UIGraphicsGetCurrentContext(), ultimoPunto.x, ultimoPunto.y);
		CGContextAddLineToPoint(UIGraphicsGetCurrentContext(), ultimoPunto.x, ultimoPunto.y);
		CGContextStrokePath(UIGraphicsGetCurrentContext());
		CGContextFlush(UIGraphicsGetCurrentContext());
		drawImage.image = UIGraphicsGetImageFromCurrentImageContext();
		UIGraphicsEndImageContext();
        
		
	}
	
}

- (IBAction) PULSAR_MENU_PIZARRA: (id) sender
{
    [self Ajustar];
    
    if (ajuste_tipo_letra<40) // IDIOMA CASTELLANO
    {
        [but_menu_cargar_imagen setTitle:@"CARGAR IMAGEN" forState:normal];
        [but_menu_deshacer setTitle:@"DESHACER" forState:normal];
        [but_menu_borrar_todo setTitle:@"BORRAR TODO" forState:normal];
        [but_menu_guardar_imagen setTitle:@"GUARDAR IMAGEN" forState:normal];
        [but_menu_inicio setTitle:@"INICIO" forState:normal];
        
        
    }
    else //IDIOMA INGLÉS
    {
        
        [but_menu_cargar_imagen setTitle:@"LOAD PICTURE" forState:normal];
        [but_menu_deshacer setTitle:@"UNDO" forState:normal];
        [but_menu_borrar_todo setTitle:@"DELETE ALL" forState:normal];
        [but_menu_guardar_imagen setTitle:@"SAVE PICTURE" forState:normal];
        [but_menu_inicio setTitle:@"HOME" forState:normal];
        
    }
    
	if (menupizarra==0){
        [VISTA_PRIMERA_PIZARRA addSubview: MENU_PIZARRA];
        [MENU_PIZARRA setFrame:CGRectMake(0, 371, 300, 309)];
        menupizarra=1;
	}
	else if (menupizarra==1){
		[MENU_PIZARRA removeFromSuperview];
		menupizarra=0;
	}
    
	
}

/*
- (IBAction) PULSAR_MENU_PIZARRA: (id) sender{
	
	
	if (menupizarra==0){
        [VISTA_PRIMERA_PIZARRA addSubview: MENU_PIZARRA];
        [MENU_PIZARRA setFrame:CGRectMake(0, 371, 300, 309)];
        menupizarra=1;
	}
	else if (menupizarra==1){
		[MENU_PIZARRA removeFromSuperview];
		menupizarra=0;
	}
    
	
}
*/
/*
- (void)PULSAR_VOLVER_MENU_PIZARRA: (id) sender{
	
    [MENU_PIZARRA removeFromSuperview];
    menupizarra=0;
	
	
}
*/

- (void)PULSAR_DESHACER: (id) sender{
	
	if (menupizarra==1){
		[MENU_PIZARRA removeFromSuperview];
		menupizarra=0;
	}
	
    drawImage.image = copyImage;
    
	
	
}


- (void)viewDidAppear:(BOOL)animated {
	[super viewDidAppear:animated];
	selectedUnit = segmentedControl.selectedSegmentIndex;
	selectedUnit1 = segmentedControl_grosor.selectedSegmentIndex;
	selectedUnit2 = segmentedControl_color.selectedSegmentIndex;
	[self cambioHerramienta];
	[self cambioGrosor];
	[self cambioColor];
	
}


- (IBAction)segmentedControlValueChanged {
	selectedUnit = segmentedControl.selectedSegmentIndex;
	[self cambioHerramienta];
	[VISTA_PRIMERA_PIZARRA setNeedsDisplay];
}

- (IBAction)segmentedControlValueChanged1 {
	selectedUnit1 = segmentedControl_grosor.selectedSegmentIndex;
	[self cambioGrosor];
	[VISTA_PRIMERA_PIZARRA setNeedsDisplay];
}

- (IBAction)segmentedControlValueChanged2 {
	selectedUnit2 = segmentedControl_color.selectedSegmentIndex;
	[self cambioColor];
	[VISTA_PRIMERA_PIZARRA setNeedsDisplay];
}

- (void)cambioHerramienta {
	
	if (menupizarra==1){
		[MENU_PIZARRA removeFromSuperview];
		menupizarra=0;
	}
	
	if (selectedUnit == 0) {
		colorRed = 0.0;
		colorGreen = 0.0;
		colorBlue = 0.0;
		segmentedControl_color.selectedSegmentIndex=0;
		[VISTA_PRIMERA_PIZARRA setNeedsDisplay];
	}
	if (selectedUnit == 1) {
		colorRed = 1.0;
		colorGreen = 1.0;
		colorBlue = 1.0;
        
		[VISTA_PRIMERA_PIZARRA setNeedsDisplay];
	}
	
}

/*
Negro = 0 0 0
Azul = 0 0 255
Verde = 0 255 0
Cián = 0 255 255
Rojo = 255 0 0
Magenta = 255 0 255
Amarillo = 255 255 0
Blanco = 255 255 255
*/

- (void)cambioColor {
	
	if (segmentedControl.selectedSegmentIndex==1){
        segmentedControl.selectedSegmentIndex=0;	
	}
	
	if (menupizarra==1){
		[MENU_PIZARRA removeFromSuperview];
		menupizarra=0;
	}
	
	if (selectedUnit2 == 0) {
		colorRed = 0.0;
		colorGreen = 0.0;
		colorBlue = 0.0;
		[VISTA_PRIMERA_PIZARRA setNeedsDisplay];
	}
	if (selectedUnit2 == 1) {
		colorRed = 1.0;
		colorGreen = 0.0;
		colorBlue = 0.0;
		[VISTA_PRIMERA_PIZARRA setNeedsDisplay];
	}
	if (selectedUnit2 == 2) {
		colorRed = 1.0;
		colorGreen = 1.0;
		colorBlue = 0.0;
		[VISTA_PRIMERA_PIZARRA setNeedsDisplay];
	}
	if (selectedUnit2 == 3) {
		colorRed = 0.0;
		colorGreen = 0.0;
		colorBlue = 1.0;
		[VISTA_PRIMERA_PIZARRA setNeedsDisplay];
	}
	if (selectedUnit2 == 4) {
		colorRed = 0.0;
		colorGreen = 1.0;
		colorBlue = 0.0;
		[VISTA_PRIMERA_PIZARRA setNeedsDisplay];
	}
	if (selectedUnit2 == 5) {
		colorRed = 1.0;
		colorGreen = 1.0;
		colorBlue = 1.0;
		[VISTA_PRIMERA_PIZARRA setNeedsDisplay];
	}
	
}

- (void)cambioGrosor {
	
	
	if (menupizarra==1){
		[MENU_PIZARRA removeFromSuperview];
		menupizarra=0;
	}
	
	if (selectedUnit1 == 0) {
		lineWidth = 1;
		[VISTA_PRIMERA_PIZARRA setNeedsDisplay];}
	if (selectedUnit1 == 1) {
		lineWidth = 5;
		[VISTA_PRIMERA_PIZARRA setNeedsDisplay];}
	if (selectedUnit1 == 2) {
		lineWidth = 10;
		[VISTA_PRIMERA_PIZARRA setNeedsDisplay];}
	if (selectedUnit1 == 3) {
		lineWidth = 20;
		[VISTA_PRIMERA_PIZARRA setNeedsDisplay];}
	if (selectedUnit1 == 4) {
		lineWidth = 30;
		[VISTA_PRIMERA_PIZARRA setNeedsDisplay];}
	if (selectedUnit1 == 5) {
		lineWidth = 35;
		[VISTA_PRIMERA_PIZARRA setNeedsDisplay];}
    
}


- (IBAction)saveDrawing {
	
	[MENU_PIZARRA removeFromSuperview];
	menupizarra=0;
	UIGraphicsBeginImageContext(self.view.bounds.size);
	[VISTA_PRIMERA_PIZARRA.layer renderInContext:UIGraphicsGetCurrentContext()];
	UIImage *finishedPic =UIGraphicsGetImageFromCurrentImageContext();
	UIGraphicsEndImageContext();
	
	UIImageWriteToSavedPhotosAlbum(finishedPic, self, @selector(exitProg:didFinishSavingWithError:contextInfo:), nil);
}

-(IBAction)cancelDrawing: (id) sender {
	
	[MENU_PIZARRA removeFromSuperview];
	menupizarra=0;
	drawImage.image = nil;
	[VISTA_PRIMERA_PIZARRA setNeedsDisplay];
	
}


-(void)exitProg:(UIImage *)image didFinishSavingWithError:(NSError *)error contextInfo:(void *)contextInfo {
	
    [self Ajustar];
    
    if (ajuste_tipo_letra<40) // IDIOMA CASTELLANO
    {
        alertView = [[UIAlertView alloc] initWithTitle:@"ENHORABUENA" message:@"Su imagen ha sido guardada" delegate:self cancelButtonTitle:nil otherButtonTitles:@"Aceptar", nil];
        
    }
    else //IDIOMA INGLÉS
    {
        alertView = [[UIAlertView alloc] initWithTitle:@"CONGRATULATIONS" message:@"Your picture has been saved" delegate:self cancelButtonTitle:nil otherButtonTitles:@"Ok", nil];   
        
    }
    
	[alertView show];
	[alertView release];
	
}

- (IBAction)choosePic: (id) sender {
	UIImagePickerController *imagePicker = [[UIImagePickerController alloc] init];
	imagePicker.delegate = self;
	imagePicker.allowsEditing = NO;
	imagePicker.sourceType = UIImagePickerControllerSourceTypePhotoLibrary;
	
	popover = [[UIPopoverController alloc]
               initWithContentViewController:imagePicker];
	[imagePicker release];
	UIButton *btnSender = sender;
	CGRect r = btnSender.frame;
	[popover presentPopoverFromRect:r inView:self.view permittedArrowDirections:UIPopoverArrowDirectionAny animated:YES];
	[MENU_PIZARRA removeFromSuperview];
}






- (void)imagePickerController:(UIImagePickerController *)picker_pizarra didFinishPickingImage:(UIImage *)image editingInfo:(NSDictionary *)editingInfo {
	
	drawImage.image=image;
	[picker_pizarra release];
	[self.popover dismissPopoverAnimated:YES];
	
}   


- (void)imagePickerControllerDidCancel:(UIImagePickerController *)picker_pizarra {
	
	[picker_pizarra release];
	[self.popover dismissPopoverAnimated:YES];
}


- (void)dealloc
{
    [segmentedControl release];
    
    [segmentedControl_grosor release];
	[copyImage release];
	
    [super dealloc];
}

@end
