//
//  VisorFotos.m
//  COMUNICADOR
//
//  Created by Elisabeth Esandia Melero on 10/04/11.
//  Copyright 2011 __MyCompanyName__. All rights reserved.
//

#import "VisorFotos.h"
#import <AssetsLibrary/AssetsLibrary.h>
#import "Ajustes.h"

#define ScrollX 70  
#define ScrollY 37
#define ScrollWidth 900 
#define ScrollHeight 600

#define ScrollXPic 200
#define ScrollWidthPic 600

@interface VisorFotos (Private)

- (void) update;

@end

@implementation VisorFotos

@synthesize album_fondo;

@synthesize ControladorAjustes;
@synthesize scroll;
@synthesize BotonSiguiente;
@synthesize BotonAnterior;
@synthesize BotonVolver;
@synthesize pictosText1;
@synthesize pictosText2;
@synthesize pictosTextNext;




#pragma mark - View lifecycle

- (void)viewDidLoad

{
    
    ControladorAjustes =[[Ajustes alloc]init];
    [self Ajustar];
    
    if (ajuste_tipo_letra<40) // IDIOMA CASTELLANO
    {
        [BotonVolver setTitle:@"VOLVER" forState:normal];
    }
    else //IDIOMA INGLÉS
    {
        [BotonVolver setTitle:@"BACK" forState:normal];
    }
    
    if((self = [super init]))
	{
		scroll = [[UIScrollView alloc] init];
		scroll.scrollEnabled = YES;
		scroll.pagingEnabled = YES;
		scroll.directionalLockEnabled = YES;
		scroll.showsVerticalScrollIndicator = NO;
		scroll.showsHorizontalScrollIndicator = YES;
		scroll.delegate = self;
		scroll.backgroundColor = [UIColor clearColor];
        scroll.autoresizesSubviews = YES;

        
        pictosText1 = [[UILabel alloc] initWithFrame:CGRectMake(0, 5, 600, 115)];
        [pictosText1 setBackgroundColor:[UIColor clearColor]];
        [pictosText1 setTextAlignment:UITextAlignmentCenter];
        pictosText1.font = [UIFont boldSystemFontOfSize: 64.0];
        
        pictosText2 = [[UILabel alloc] initWithFrame:CGRectMake(0, 5, 600, 115)];
        [pictosText2 setBackgroundColor:[UIColor clearColor]];
        [pictosText2 setTextAlignment:UITextAlignmentCenter];
        pictosText2.font = [UIFont boldSystemFontOfSize: 64.0];
        
        pictosTextNext = [[UILabel alloc] initWithFrame:CGRectMake(0, 5, 600, 115)];
        [pictosTextNext setBackgroundColor:[UIColor clearColor]];
        [pictosTextNext setTextAlignment:UITextAlignmentCenter];
        pictosTextNext.font = [UIFont boldSystemFontOfSize: 64.0];
        
        
        // Cambiamos el tamaño del visor dependiendo de si estamos mostrando pictos o no.
        if (metodoCarga==1)//mostramos pictos. 
        {
            [album_fondo setImage:[UIImage imageNamed:[NSString stringWithFormat:@"album_fondo_pictos.png"]]];
            scroll.frame = CGRectMake(ScrollXPic, ScrollY, ScrollWidthPic, ScrollHeight);
            //scroll.contentSize = CGSizeMake(NumImages*ScrollWidthPic, ScrollHeight); //tamaño total del scroll
        }
        else if(metodoCarga==0) // Mostramos assets
        {
            [album_fondo setImage:[UIImage imageNamed:[NSString stringWithFormat:@"album_fondo_assets.png"]]];
            scroll.frame = CGRectMake(ScrollX, ScrollY, ScrollWidth, ScrollHeight);
            //scroll.contentSize = CGSizeMake(NumImages*ScrollWidth, ScrollHeight); //tamaño total del scroll
        }
        
		[self.view addSubview:scroll];
		
        nextView = [[UIImageView alloc] init];
        
		view1 = [[UIImageView alloc] init];
		[scroll addSubview:view1];
		
		view2 = [[UIImageView alloc] init];
		[scroll addSubview:view2];
        
         //cargarFotosPagActual=[[cargarFotos alloc]initWithNibName:@"cargarFotos" bundle:[NSBundle mainBundle]];
	}
	
	//return self;
    
}

- (void)Ajustar
{
    [ControladorAjustes viewDidLoad];
    ajuste_resp_negativa=ControladorAjustes.resp_negativa;
    ajuste_tiempo_pulsacion=ControladorAjustes.tiempo_pulsacion;
    ajuste_tipo_letra=ControladorAjustes.tipo_letra;
    
    if (ajuste_tipo_letra==20){
        Idioma=@"nombre";
    }
    else if (ajuste_tipo_letra==30){
        Idioma=@"nombre_may";
    }
    else if (ajuste_tipo_letra==50){
        Idioma=@"nombre_ing";
    }
    else if (ajuste_tipo_letra==60){
        Idioma=@"nombre_may_ing";
    }
    
    NSLog(@"respuesta negativa %i, tiempo pulsacion %i, tipo letra %i",ajuste_resp_negativa,ajuste_tiempo_pulsacion,ajuste_tipo_letra);
}

- (BOOL)shouldAutorotateToInterfaceOrientation:(UIInterfaceOrientation)interfaceOrientation
{
    // Return YES for supported orientations
	return NO;
}

/*
- (id)initWithNibName:(NSString *)nibNameOrNil bundle:(NSBundle *)nibBundleOrNil
{
    self = [super initWithNibName:nibNameOrNil bundle:nibBundleOrNil];
    if (self) {
        // Custom initialization
    }
    return self;
}
*/
-(void)cargarImagen:(int)imagen_inic cargarArray:(NSMutableArray*)nuevasImagenes metodo:(BOOL)metodoDeCarga
{
    [imageSet autorelease];
	
	imageSet = [nuevasImagenes retain]; //imageSet:array de assets(imagenes).
    
    metodoCarga = metodoDeCarga;
    
    NumImages= [imageSet count]; // nº de imagenes dentro del array

    imagen_inicial = imagen_inic; //imagen que se ha clickado y hay que colocar la primera.
    
    [self viewDidLoad];
    
    if (imagen_inicial<NumImages-1) //Vemos si es la primera, la última o una imagen entre medio.
    {        
        if (metodoDeCarga==1) // NSMutableArray = Assets
        {
            
            view1.frame = CGRectMake((ScrollWidthPic*imagen_inicial), 0, ScrollWidthPic, ScrollHeight); //Establecemos la posicion correspondiente a la imagen elegida dentro del scroll
            view2.frame = CGRectMake((ScrollWidthPic*(imagen_inicial+1)), 0, ScrollWidthPic, ScrollHeight);
            
            view1.image = [UIImage imageNamed:[[imageSet objectAtIndex:(imagen_inicial)] valueForKey:@"nombre"]];
            view2.image = [UIImage imageNamed:[[imageSet objectAtIndex:(imagen_inicial+1)] valueForKey:@"nombre"]];
            
            [pictosText1 setText:[[imageSet objectAtIndex:(imagen_inicial)] valueForKey:Idioma]];
            [pictosText2 setText:[[imageSet objectAtIndex:(imagen_inicial+1)] valueForKey:Idioma]];
            
            [view1 addSubview:pictosText1];
            [view2 addSubview:pictosText2];
            
        }
        else //NSMutableArray = imagenes normales

        {
            view1.frame = CGRectMake((ScrollWidth*imagen_inicial), 0, ScrollWidth, ScrollHeight); //Establecemos la posicion correspondiente a la imagen elegida dentro del scroll
            view2.frame = CGRectMake((ScrollWidth*(imagen_inicial+1)), 0, ScrollWidth, ScrollHeight);
            
            view1.image = [UIImage imageWithCGImage:[[[imageSet objectAtIndex:imagen_inicial]defaultRepresentation]fullScreenImage]];//Imagen elegida y siguiente
            view2.image = [UIImage imageWithCGImage:[[[imageSet objectAtIndex:imagen_inicial+1]defaultRepresentation]fullScreenImage]];

        }
    }
    else
    {        
        if (metodoDeCarga==1) 
        {
            view1.frame = CGRectMake((ScrollWidthPic*imagen_inicial), 0, ScrollWidthPic, ScrollHeight); //Establecemos la posicion correspondiente a la imagen elegida dentro del scroll
            view2.frame = CGRectMake((ScrollWidthPic*(imagen_inicial-1)), 0, ScrollWidthPic, ScrollHeight);
            
            view1.image = [UIImage imageNamed:[[imageSet objectAtIndex:(imagen_inicial)] valueForKey:@"nombre"]];
            view2.image = [UIImage imageNamed:[[imageSet objectAtIndex:(imagen_inicial-1)] valueForKey:@"nombre"]];
            
            [pictosText1 setText:[[imageSet objectAtIndex:(imagen_inicial)] valueForKey:Idioma]];
            [pictosText2 setText:[[imageSet objectAtIndex:(imagen_inicial-1)] valueForKey:Idioma]];
            
            [view1 addSubview:pictosText1];
            [view2 addSubview:pictosText2];
        }
        else
        {
            view1.frame = CGRectMake((ScrollWidth*imagen_inicial), 0, ScrollWidth, ScrollHeight); //Establecemos la posicion correspondiente a la imagen elegida dentro del scroll
            view2.frame = CGRectMake((ScrollWidth*(imagen_inicial-1)), 0, ScrollWidth, ScrollHeight);
            
            view1.image = [UIImage imageWithCGImage:[[[imageSet objectAtIndex:imagen_inicial]defaultRepresentation]fullScreenImage]];//Imagen elegida y siguiente
            view2.image = [UIImage imageWithCGImage:[[[imageSet objectAtIndex:imagen_inicial-1]defaultRepresentation]fullScreenImage]];
        }
    }

    if (metodoCarga==1)
    {
        [scroll setContentOffset:CGPointMake((ScrollWidthPic*imagen_inicial), ScrollY)]; //Cargar imagen inicial en el scroll
        scroll.contentSize = CGSizeMake([imageSet count]*ScrollWidthPic, ScrollHeight); //tamaño total del scroll
    }
    else
    {
        [scroll setContentOffset:CGPointMake((ScrollWidth*imagen_inicial), ScrollY)]; //Cargar imagen inicial en el scroll
        scroll.contentSize = CGSizeMake([imageSet count]*ScrollWidth, ScrollHeight); //tamaño total del scroll
    }
    
    NSLog(@"Imagen pasada = %i",imagen_inicial);

}


-(IBAction)volverFotos:(id)sender
{
    [self.view removeFromSuperview];
}


-(IBAction)pulsarImagSiguiente:(id)sender
{
	float currPos = scroll.contentOffset.x;
    
    if (metodoCarga==1) 
    {
        int selectedPage = roundf(currPos / ScrollWidthPic);
        
        [scroll scrollRectToVisible:CGRectMake(ScrollWidthPic*(selectedPage+1), ScrollY, ScrollWidthPic, ScrollHeight) animated:YES];
    }
    else
    {
        int selectedPage = roundf(currPos / ScrollWidth);
        
        [scroll scrollRectToVisible:CGRectMake(ScrollWidth*(selectedPage+1), ScrollY, ScrollWidth, ScrollHeight) animated:YES];  
    }
}

-(IBAction)pulsarImagAnterior:(id)sender
{
	float currPos = scroll.contentOffset.x;
    
    if (metodoCarga==1) 
    {     
        int selectedPage = roundf(currPos / ScrollWidthPic);
        
        [scroll scrollRectToVisible:CGRectMake(ScrollWidthPic*(selectedPage-1), ScrollY, ScrollWidthPic, ScrollHeight) animated:YES];
    }
    else
    {
        int selectedPage = roundf(currPos / ScrollWidth);
        
        [scroll scrollRectToVisible:CGRectMake(ScrollWidth*(selectedPage-1), ScrollY, ScrollWidth, ScrollHeight) animated:YES]; 
    }
}


# pragma mark -
# pragma mark UIScrollView Delegate

- (void) scrollViewDidScroll:(UIScrollView *) scrollView
{	
	[self update];
}


- (void) update
{
    CGFloat pageWidth=0;
    
    if (metodoCarga==1) 
    {
        pageWidth = ScrollWidthPic;
    }
    else
    {
        pageWidth = ScrollWidth;
    }
    
    float currPos = scroll.contentOffset.x; //Posición del scroll en cada momento
    
	int selectedPage = roundf(currPos / pageWidth); //Página que se ve en cada momento (empieza en la cero=0)
	
	float truePosition = selectedPage*pageWidth; //coordenadas de la página actual dentro del scroll
	
	int zone = selectedPage % 2; //Comprobamos el resto de la pág/2. ZONE=0 --> pág.Par - ZONE=1 --> pág.Impar
	
	BOOL view1Active = zone == 0; //view1Active=1 si ZONA PAR
    
    //////////////////////////////////////////
    // OCULTAR / MOSTRAR BOTONES NAVEGACION //
    //////////////////////////////////////////
    
    if (0<selectedPage)
    {
        [BotonSiguiente setHidden:NO];
        [BotonSiguiente setEnabled:YES];
        [BotonAnterior setHidden:NO];
        [BotonAnterior setEnabled:YES];
        if ((selectedPage==[imageSet count]-1)) 
        {
            [BotonSiguiente setHidden:YES];
            [BotonSiguiente setEnabled:NO];
        }
    }
    else
    {
        [BotonAnterior setHidden:YES];
        [BotonAnterior setEnabled:NO];
        
        if ((selectedPage==[imageSet count]-1)) 
        {
            [BotonSiguiente setHidden:YES];
            [BotonSiguiente setEnabled:NO];
        }
    }
    
    //////////////////////////////////////////
    // SACAR LA IMAGEN CORRESPONDIENTE //
    //////////////////////////////////////////
    
    if(imagen_inicial%2==0)
    {
        NSLog(@"la imagen seleccionada es par");
        if (view1Active)// if ZONA==PAR --> nextView=view2; else -->nextView=view1
        {
            nextView=view2;
            pictosTextNext=pictosText2;
        }
        else
        {
            nextView=view1;
            pictosTextNext=pictosText1;
        }
    }
    else
    {
        NSLog(@"la imagen seleccionada es impar");
        
        if (view1Active)// if ZONA==IMPAR --> nextView=view1; else -->nextView=view2
        {
            nextView=view1;
            pictosTextNext=pictosText1;
        }
        else
        {
            nextView=view2;
            pictosTextNext=pictosText2;
        }
    }
	
	int nextpage = truePosition > currPos ? selectedPage-1 : selectedPage+1; //Nos movemos hacia la izq. o la dcha.
	
	if(nextpage >= 0 && nextpage < [imageSet count])
	{
		if((view1Active && nextpage == view1Index) || (!view1Active && nextpage == view2Index)) return;
		
		NSLog(@"Load next image!");
		
        if (metodoCarga==1) 
        {
            nextView.frame = CGRectMake(nextpage*ScrollWidthPic, 0, ScrollWidthPic, ScrollHeight);
            
            nextView.image = [UIImage imageNamed:[[imageSet objectAtIndex:(nextpage)] valueForKey:@"nombre"]];
            [pictosTextNext setText:[[imageSet objectAtIndex:(nextpage)] valueForKey:Idioma]];
        }
        else
        {
            nextView.frame = CGRectMake(nextpage*ScrollWidth, 0, ScrollWidth, ScrollHeight);
            
            nextView.image = [UIImage imageWithCGImage:[[[imageSet objectAtIndex:nextpage]defaultRepresentation]fullScreenImage]];
        }
        
		if(view1Active)
            view1Index = nextpage;
		else
            view2Index = nextpage;
	}
    
    
}

# pragma mark -
# pragma mark Memory Management

- (void)viewDidUnload
{
    [super viewDidUnload];
    self.BotonSiguiente=nil;
    self.BotonAnterior=nil;
    // Release any retained subviews of the main view.
    // e.g. self.myOutlet = nil;
}

- (void)dealloc
{
    //[cargarFotosPagActual release];
    [scroll release];
    [nextView release];
    [pictosText1 release];
    [pictosText2 release];
    [pictosTextNext release];

    
    [view1 release];
    [view2 release];
    [imageSet release];
    [BotonAnterior release];
    [BotonSiguiente release];
    [super dealloc];
}

- (void)didReceiveMemoryWarning
{
    // Releases the view if it doesn't have a superview.
    [super didReceiveMemoryWarning];
    
    // Release any cached data, images, etc that aren't in use.
}




@end
